//============================================================================
// Name        : OpenCVHoughCircle.cpp
// Author      : Ruediger Knoerig
// Version     :
// Copyright   : GPL
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include "cv.h"
#include "highgui.h"
#include <string>
#include <vector>

using namespace std;
using namespace cv;
// Test
int main() {
	try {

		VideoCapture cap(0); // open the default camera
		if (!cap.isOpened()) throw string("Konnte keine Kamera aktivieren!");
		Mat bild,graustufen;
		namedWindow("Anzeige", 1);
		for (;;) {
			cap >> bild; // get a new frame from camera
			cvtColor(bild, graustufen, CV_BGR2GRAY);
			GaussianBlur( graustufen, graustufen,Size(3,3), 2, 2 );
			Canny(graustufen,graustufen, 50, 200, 3 );
			vector<Vec4i> linien;
			HoughLinesP(graustufen, linien, 1, CV_PI/180, 80, 30, 10 );
			for( size_t i = 0; i < linien.size(); i++ )
			  {
			    line(bild, Point(linien[i][0], linien[i][1]),
				  Point(linien[i][2], linien[i][3]), Scalar(0,0,255), 3, 8 );
			  }
			imshow("Anzeige",bild);
			if (waitKey(30) >= 0)
				break;
		}
		vector<int> attribute(2);
		attribute[0] = CV_IMWRITE_JPEG_QUALITY;
		attribute[1] = 90;
		imwrite(string("Bild.jpg"), bild, attribute);
		return 0;
	} catch (string msg) {
		cerr << "Ein Fehler ist aufgetreten!" << endl << msg << endl;
		return -1;
	}
}

